<?php

include ('../database/database_wrapper.php');

function cors() {

    // Allow from any origin
    if (isset($_SERVER['HTTP_ORIGIN'])) {
        // Decide if the origin in $_SERVER['HTTP_ORIGIN'] is one
        // you want to allow, and if so:
        header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
        header('Access-Control-Allow-Credentials: true');
        header('Access-Control-Max-Age: 86400');    // cache for 1 day
    }

    // Access-Control headers are received during OPTIONS requests
    if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
            // may also be using PUT, PATCH, HEAD etc
            header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         

        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
            header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");

        exit(0);
    }

    //echo "You have CORS!";
}

cors();

// one will get something like this:
// http://192.168.0.222/events/add_new_control_event.php?controlParameters={%22ventilation%22:%22false%22,%22ventilationMode%22:%22CMV%22,%22VT%22:%22924%22,%22RR%22:%2200%22,%22PEEP%22:%2200%22,%22Trigger%22:%2200%22,%22IE%22:%2200%22,%22Pmax%22:%2200%22,%22Pinsp%22:%22%22}&userId=40ed0e90-7a63-11ea-bb94-173858911466
// works:	1ea7a6340ed0e90bb94173858911466
// not yet:	40ed0e90 7a63 11ea bb94 173858911466

/*
Word=40ed0e90
Word=7a63
Word=11ea
Word=bb94
Word=173858911466
*/
if (isset($_GET['controlParameters']) && isset($_GET['userId']))
{
  $string = $_GET['userId'];
  $firstPartOfID = strtok($string, "-");
  $secondPartOfID = strtok("-");
  $thirdPartOfID = strtok("-");
  $fourthPartOfID = strtok("-");
  $fivethPartOfID = strtok("-");

  $realUserID = substr($thirdPartOfID, 1) . $secondPartOfID . $firstPartOfID . $fourthPartOfID . $fivethPartOfID;

  $decodedControlParametersJSON = json_decode($_GET['controlParameters']);

  print_r($decodedControlParametersJSON);

  $something = array(
    'parameters' => $_GET['controlParameters'],
    'user_id' => $realUserID
  );

  echo dbw_addNewControlEvent($something);
}
else
{
  echo 'NOT OK';
}


?>
